diff -urpN john-1.7.8-jumbo-6-rc2/src/PHPS_fmt_plug.c john-1.7.8-jumbo-6b/src/PHPS_fmt_plug.c
--- john-1.7.8-jumbo-6-rc2/src/PHPS_fmt_plug.c	2011-06-02 15:19:49.000000000 +0000
+++ john-1.7.8-jumbo-6b/src/PHPS_fmt_plug.c	2011-09-14 16:45:36.609375000 +0000
@@ -37,22 +37,10 @@
 #include "md5_gen.h"
 
 #define FORMAT_LABEL		"phps"
-#define FORMAT_NAME			"PHPS MD5"
-#ifdef MMX_COEF
-#if (MMX_COEF == 2)
-#define ALGORITHM_NAME		"MD5(MD5($pass).$salt) MMX"
-#else
-#define ALGORITHM_NAME		"MD5(MD5($pass).$salt) SSE2"
-#endif
-#else
-#define ALGORITHM_NAME		"MD5(MD5($pass).$salt) MD5"
-#endif
-
-#ifdef MMX_TYPE
-#define BENCHMARK_COMMENT		MMX_TYPE
-#else
-#define BENCHMARK_COMMENT		""
-#endif
+#define FORMAT_NAME			"PHPS -- md5(md5($pass).$salt)"
+
+#define ALGORITHM_NAME		"?" /* filled in by md5-gen */
+#define BENCHMARK_COMMENT	""
 #define BENCHMARK_LENGTH	0
 
 #define MD5_BINARY_SIZE		16
@@ -161,6 +149,7 @@ static void phps_init(struct fmt_main *p
 		pFmt_MD5_gen_6 = md5_gen_THIN_FORMAT_LINK(&fmt_PHPS, Convert(Conv_Buf, phps_tests[0].ciphertext), "phps");
 		fmt_PHPS.methods.salt   = our_salt;
 		fmt_PHPS.methods.binary = our_binary;
+		fmt_PHPS.params.algorithm_name = pFmt_MD5_gen_6->params.algorithm_name;
 		pFmt->private.initialized = 1;
 	}
 }
diff -urpN john-1.7.8-jumbo-6-rc2/src/bench.c john-1.7.8-jumbo-6b/src/bench.c
--- john-1.7.8-jumbo-6-rc2/src/bench.c	2011-09-13 11:39:53.578125000 +0000
+++ john-1.7.8-jumbo-6b/src/bench.c	2011-09-14 16:37:03.812500000 +0000
@@ -370,6 +370,11 @@ int benchmark_all(void)
 					printf("Note: Running both MPI and OMP (see doc/README.mpi)\n\n");
 		}
 #endif
+		/* to get 'thin' md5_gen formats to use the 'proper' signatures, we have to init NOW,
+		 * prior to printing out the signature line.  This allows the thin format to update
+		 * its signature, based upon the underlying md5-gen sub format being used */
+		fmt_init(format);
+
 		printf("Benchmarking: %s%s [%s]%s... ",
 			format->params.format_name,
 			format->params.benchmark_comment,
diff -urpN john-1.7.8-jumbo-6-rc2/src/config.c john-1.7.8-jumbo-6b/src/config.c
--- john-1.7.8-jumbo-6-rc2/src/config.c	2011-09-13 13:57:11.375000000 +0000
+++ john-1.7.8-jumbo-6b/src/config.c	2011-09-14 13:49:53.984375000 +0000
@@ -301,8 +301,8 @@ static int cfg_process_directive_include
 			return 0;
 		}
 	}
-	fprintf(stderr, "ERROR, could not find include section:  %s:%s]\n", line, Section);
-	log_event("! ERROR, could not find include section:  %s:%s]", line, Section);
+	fprintf(stderr, "ERROR, could not find include section:  %s%s]\n", line, Section);
+	log_event("! ERROR, could not find include section:  %s%s]", line, Section);
 	return 1;
 }
 
diff -urpN john-1.7.8-jumbo-6-rc2/src/john.c john-1.7.8-jumbo-6b/src/john.c
--- john-1.7.8-jumbo-6-rc2/src/john.c	2011-09-13 10:58:24.828125000 +0000
+++ john-1.7.8-jumbo-6b/src/john.c	2011-09-14 16:23:58.562500000 +0000
@@ -176,6 +176,9 @@ static void john_log_format(void)
 	if (mpi_p > 1)
 		log_event("- MPI mode: %u nodes, this one running on %s", mpi_p, mpi_name);
 #endif
+	/* make sure the format is properly initialized */
+	fmt_init(database.format);
+
 	log_event("- Hash type: %.100s (lengths up to %d%s)",
 		database.format->params.format_name,
 		database.format->params.plaintext_length,
@@ -307,6 +310,8 @@ static void john_load(void)
 			else
 				log_event("Starting a new session");
 			log_event("Loaded a total of %s", john_loaded_counts());
+			/* make sure the format is properly initialized */
+			fmt_init(database.format);
 			printf("Loaded %s (%s [%s])\n",
 				john_loaded_counts(),
 				database.format->params.format_name,
diff -urpN john-1.7.8-jumbo-6-rc2/src/md5_gen_fmt.c john-1.7.8-jumbo-6b/src/md5_gen_fmt.c
--- john-1.7.8-jumbo-6-rc2/src/md5_gen_fmt.c	2011-09-13 11:02:33.140625000 +0000
+++ john-1.7.8-jumbo-6b/src/md5_gen_fmt.c	2011-09-14 16:37:03.765625000 +0000
@@ -6751,13 +6751,6 @@ struct fmt_main *md5_gen_THIN_FORMAT_LIN
 	if (!valid)
 		exit(fprintf(stderr, "Error, trying to link to %s using ciphertext=%s FAILED\n", subformat, ciphertext));
 
-	printf ("Using %s mode, by linking to %s functions", orig_sig, subformat);
-	// If benchmarking, simply add a space.  If not, then add a newline.
-	if (options.flags & FLG_TEST_CHK)
-		printf (" ");
-	else
-		printf ("\n");
-
 	pFmt->params.max_keys_per_crypt = pFmtLocal->params.max_keys_per_crypt;
 	pFmt->params.min_keys_per_crypt = pFmtLocal->params.min_keys_per_crypt;
 	pFmt->methods.cmp_all    = pFmtLocal->methods.cmp_all;
diff -urpN john-1.7.8-jumbo-6-rc2/src/mediawiki_fmt_plug.c john-1.7.8-jumbo-6b/src/mediawiki_fmt_plug.c
--- john-1.7.8-jumbo-6-rc2/src/mediawiki_fmt_plug.c	2011-06-08 16:24:06.000000000 +0000
+++ john-1.7.8-jumbo-6b/src/mediawiki_fmt_plug.c	2011-09-14 16:47:30.281250000 +0000
@@ -47,22 +47,10 @@ userName2:$B$107$dd494cb03ac1c5b8f8d2ddd
 #include "md5_gen.h"
 
 #define FORMAT_LABEL		"mediawiki"
-#define FORMAT_NAME			"MediaWiki MD5s"
-#ifdef MMX_COEF
-#if (MMX_COEF == 2)
-#define ALGORITHM_NAME		"MD5($s.'-'.md5($p)) MMX"
-#else
-#define ALGORITHM_NAME		"MD5($s.'-'.md5($p)) SSE2"
-#endif
-#else
-#define ALGORITHM_NAME		"MD5($s.'-'.md5($p)) MD5"
-#endif
-
-#ifdef MMX_TYPE
-#define BENCHMARK_COMMENT		MMX_TYPE
-#else
-#define BENCHMARK_COMMENT		""
-#endif
+#define FORMAT_NAME			"MediaWiki -- md5($s.'-'.md5($p))"
+
+#define ALGORITHM_NAME		"?" /* filled in by md5-gen */
+#define BENCHMARK_COMMENT	""
 #define BENCHMARK_LENGTH	0
 
 #define MD5_BINARY_SIZE		16
@@ -168,6 +156,7 @@ static void mediawiki_init(struct fmt_ma
 		pFmt_MD5_gen_9 = md5_gen_THIN_FORMAT_LINK(&fmt_mediawiki, Convert(Conv_Buf, mediawiki_tests[0].ciphertext), "mediawiki");
 		fmt_mediawiki.methods.salt   = our_salt;
 		fmt_mediawiki.methods.binary = our_binary;
+		fmt_mediawiki.params.algorithm_name = pFmt_MD5_gen_9->params.algorithm_name;
 		pFmt->private.initialized = 1;
 	}
 }
diff -urpN john-1.7.8-jumbo-6-rc2/src/phpassMD5_fmt_plug.c john-1.7.8-jumbo-6b/src/phpassMD5_fmt_plug.c
--- john-1.7.8-jumbo-6-rc2/src/phpassMD5_fmt_plug.c	2011-07-06 14:28:50.000000000 +0000
+++ john-1.7.8-jumbo-6b/src/phpassMD5_fmt_plug.c	2011-09-14 16:43:24.046875000 +0000
@@ -39,21 +39,9 @@
 
 #define FORMAT_LABEL			"phpass-md5"
 #define FORMAT_NAME				"PHPass MD5"
-#ifdef MMX_COEF
-#if (MMX_COEF == 2)
-#define ALGORITHM_NAME			"phpass-MD5 MMX"
-#else
-#define ALGORITHM_NAME			"phpass-MD5 SSE2"
-#endif
-#else
-#define ALGORITHM_NAME			"phpass-md5"
-#endif
-
-#ifdef MMX_TYPE
-#define BENCHMARK_COMMENT		MMX_TYPE
-#else
+
+#define ALGORITHM_NAME			"?" /* filled in by md5-gen */
 #define BENCHMARK_COMMENT		""
-#endif
 #define BENCHMARK_LENGTH		-1
 
 #define PLAINTEXT_LENGTH		38
@@ -147,6 +135,7 @@ static void phpassmd5_init(struct fmt_ma
 		pFmt_MD5_gen_17 = md5_gen_THIN_FORMAT_LINK(&fmt_phpassmd5, Convert(Conv_Buf, phpassmd5_tests[0].ciphertext), "phpass");
 		fmt_phpassmd5.methods.salt   = our_salt;
 		fmt_phpassmd5.methods.binary = our_binary;
+		fmt_phpassmd5.params.algorithm_name = pFmt_MD5_gen_17->params.algorithm_name;
 		pFmt->private.initialized = 1;
 	}
 }
diff -urpN john-1.7.8-jumbo-6-rc2/src/rawMD5go_fmt_plug.c john-1.7.8-jumbo-6b/src/rawMD5go_fmt_plug.c
--- john-1.7.8-jumbo-6-rc2/src/rawMD5go_fmt_plug.c	2011-06-02 15:19:49.000000000 +0000
+++ john-1.7.8-jumbo-6b/src/rawMD5go_fmt_plug.c	2011-09-14 16:42:02.281250000 +0000
@@ -24,8 +24,8 @@
 #include "md5_gen.h"
 
 #define FORMAT_LABEL			"raw-md5"
-#define FORMAT_NAME			"Raw MD5"
-#define ALGORITHM_NAME			"gen"
+#define FORMAT_NAME				"Raw MD5"
+#define ALGORITHM_NAME			"?"  /* filled in by md5-gen */
 
 #define BENCHMARK_COMMENT		""
 #define BENCHMARK_LENGTH		-1
@@ -106,6 +106,7 @@ static void rawmd5_init(struct fmt_main
 		pFmt_MD5_gen_0 = md5_gen_THIN_FORMAT_LINK(&fmt_rawMD5go, Convert(Conv_Buf, rawmd5_tests[0].ciphertext), "raw-md5");
 		fmt_rawMD5go.methods.binary = our_binary;
 		fmt_rawMD5go.methods.salt = our_salt;
+		fmt_rawMD5go.params.algorithm_name = pFmt_MD5_gen_0->params.algorithm_name;
 		pFmt->private.initialized = 1;
 	}
 }
diff -urpN john-1.7.8-jumbo-6-rc2/src/rawmd5u_fmt_plug.c john-1.7.8-jumbo-6b/src/rawmd5u_fmt_plug.c
--- john-1.7.8-jumbo-6-rc2/src/rawmd5u_fmt_plug.c	2011-09-13 11:02:33.140625000 +0000
+++ john-1.7.8-jumbo-6b/src/rawmd5u_fmt_plug.c	2011-09-14 16:45:19.015625000 +0000
@@ -29,9 +29,9 @@
 #include "unicode.h"
 
 #define FORMAT_LABEL			"raw-md5u"
-#define FORMAT_NAME			"md5(unicode($p))"
-#define ALGORITHM_NAME			"gen"
+#define FORMAT_NAME				"md5(unicode($p))"
 
+#define ALGORITHM_NAME			"?" /* filled in by md5-gen */
 #define BENCHMARK_COMMENT		""
 #define BENCHMARK_LENGTH		-1
 
@@ -139,6 +139,7 @@ static void rawmd5u_init(struct fmt_main
 		pFmt_MD5_gen_29 = md5_gen_THIN_FORMAT_LINK(&fmt_rawmd5u, Convert(Conv_Buf, rawmd5u_tests[0].ciphertext), "thin");
 		fmt_rawmd5u.methods.binary = our_binary;
 		fmt_rawmd5u.methods.salt = our_salt;
+		fmt_rawmd5u.params.algorithm_name = pFmt_MD5_gen_29->params.algorithm_name;
 		pFmt->private.initialized = 1;
 	}
 }